#target Photoshop

app.activeDocument.suspendHistory("makeSetPattern", "main()");

function main(){
	var firstLwText = 2;	// 初期値_線幅
	var firstIText = 8;		// 初期値_間隔
	var firstLIText = 4;	// 初期値_線間隔
	var firstDText = 6;		// 初期値_深さ
	var firstSIText = 1;	// 初期値_サイズ間隔
	var firstL = 10;
	var firstT = 10;
	var lineheight = 30;
	var secondL = 30;
	var secondT = firstT + lineheight + 240;

	var widthType1 = 80;
	var widthType2 = 160;
	var widthType3 = 120;

	var lwW = 40;
	var lwtW = 30;
	var interW = 90;
	var thirdT = secondT + lineheight;
	var fourthT = thirdT + lineheight + 10;
	var descriptT = fourthT + 40;
	var btnL = 240;
	var btnT = descriptT + lineheight + 50;
	var typeIdAry = new Array('Horizontal'/*0*/, 'Vertical'/*1*/, 'Diagonal'/*2*/, 'Circle'/*3*/, 'Circle_deg45'/*4*/,
							  'Square'/*5*/, 'Square_deg45'/*6*/, 'Harlequin'/*7*/,
							  'Jagged'/*8*/, 'Grid_deg45'/*9*/, 'DotGrd'/*10*/);
	var typeNameAry = new Array('水平'/*0*/, '垂直'/*1*/, '斜線'/*2*/, 'ドット'/*3*/, 'ドット（斜め）'/*4*/,
								'正方形'/*5*/, '正方形（斜め）'/*6*/, 'ハーリキン・チェック'/*7*/,
								'ギザギザ'/*8*/, '方眼（斜め）'/*9*/,'ドットグラデ'/*10*/);
	var typeWidthAry = new Array(widthType1/*0*/, widthType1/*1*/, widthType1/*2*/, widthType1/*3*/, widthType3/*4*/,
								widthType1/*5*/, widthType2/*6*/, widthType2/*7*/,
								widthType1/*8*/, widthType2/*9*/, widthType2/*10*/);
	var mainNumObj = new Object();
	var dirRBObj = new Object();
	var optCBObj = new Object();
	var optObj = new Object();

	// ダイアログ作成
	var dialog = new Window('dialog','シンプルパターン作成＆登録',[200,100,680,640]);
	var dlgB = dialog.bounds.bottom;
	var dlgR = dialog.bounds.right;

	// サムネ画像の配置場所を指定
	var fullFilepath = $.fileName;
	var filename = $.fileName.split('/').pop();
	var path = fullFilepath.replace(filename, '');

	// ダイアログの項目を作成、配置
	var left;
	var top;
	var turnN = 5;
	var sturnN = 8;
	var thumbAry = new Array();
	var thumbW = 40;

	for(var i=0; i<typeIdAry.length; i++){
		if(i==0 || i==turnN || i==sturnN){
			left = firstL;
		}else{
			left = dirRBObj[typeIdAry[i-1]].bounds.left+typeWidthAry[i-1];
		}
		if(i>=sturnN){
			top = firstT+(lineheight+60-5)*2;
		}else if(i>=turnN && i<sturnN){
			top = firstT+lineheight+60-5;
		}else{
			top = firstT;
		}
		dirRBObj[typeIdAry[i]] = dialog.add('radiobutton', [left, top, left, top+lineheight], typeNameAry[i]);
		var thumbObj = new Object();
		thumbObj.top = top;
		thumbObj.left = left;
		thumbAry[i] = thumbObj;
	}

	// サムネをラジオボタンと同時に作成するとラジオボタンが切り替わらないバグが起きたため分けて作成
	for(var i=0; i<typeIdAry.length; i++){
		var img = dialog.add('image', [thumbAry[i].left+20, thumbAry[i].top+30, thumbAry[i].left+thumbW+20, thumbAry[i].top+thumbW+30],
							 path + 'images/img_' + typeIdAry[i] + '.png');
	}

	mainNumObj['lwText'] = dialog.add('statictext',[ secondL, secondT, secondL+lwW, secondT+25], '線幅');
	mainNumObj['linewidthText'] = dialog.add('edittext',[secondL+lwW, secondT, secondL+lwW+lwtW, secondT+lineheight], firstLwText);
	mainNumObj['iText'] = dialog.add('statictext',[ secondL+interW, secondT, secondL+interW+lwW, secondT+25], '間隔');
	mainNumObj['intervalText'] = dialog.add('edittext',[ secondL+interW+lwW, secondT, secondL+interW+lwW+lwtW, secondT+lineheight], firstIText);
	mainNumObj['liText'] = dialog.add('statictext',[ secondL+interW*2, secondT, secondL+interW*2+lwW, secondT+25], '線間隔');
	mainNumObj['lineintervalText'] = dialog.add('edittext',[ secondL+interW*2+lwW+30, secondT, secondL+interW*2+lwW+lwtW, secondT+lineheight], firstLIText);

	mainNumObj['dText'] = dialog.add('statictext',[ secondL, thirdT, secondL+lwW, thirdT+25], '深さ');
	mainNumObj['deepText'] = dialog.add('edittext',[secondL+lwW, thirdT, secondL+lwW+lwtW, thirdT+lineheight], firstDText);
	mainNumObj['siText'] = dialog.add('statictext',[ secondL+interW, thirdT, secondL+interW+lwW+40, thirdT+25], 'サイズ間隔');
	mainNumObj['sizeintervalText'] = dialog.add('edittext',[secondL+interW+lwW+40, thirdT, secondL+interW+lwW+lwtW+40, thirdT+lineheight], firstSIText);

	optCBObj['pullShape'] = dialog.add('checkbox',[secondL, fourthT, secondL+2*20, fourthT+lineheight], '抜き');
	optCBObj['rightUp'] = dialog.add('checkbox',[optCBObj['pullShape'].bounds.right+10, fourthT, optCBObj['pullShape'].bounds.right+10+4*20, fourthT+lineheight], '右上がり');
	optCBObj['h2times'] = dialog.add('checkbox',[optCBObj['rightUp'].bounds.right+10, fourthT, optCBObj['rightUp'].bounds.right+10+4*20, fourthT+lineheight], '高さ2倍');

	var desctxtObj = new Object();
	var CR = String.fromCharCode(13);
	desctxtObj['cmn'] = '※単位はpx';
	desctxtObj['common'] = desctxtObj['cmn']+' '+CR+CR+CR;
	desctxtObj['circle'] = desctxtObj['cmn']+CR+
				'※線幅：ドットの直径'+CR+
				'※間隔：ドットの左右の間隔'+CR+
				'※線間隔：ドットの上下の間隔';
	desctxtObj['square'] = desctxtObj['cmn']+CR+
				'※線幅：正方形の1辺の長さ'+CR+
				'※間隔：正方形の左右の間隔'+CR+
				'※線間隔：正方形の上下の間隔';
	desctxtObj['harlequin'] = desctxtObj['cmn']+CR+
				'※線幅：正方形の1辺の長さ'+CR+CR;
	desctxtObj['grid'] = desctxtObj['cmn']+CR+
				'※線幅：方眼の線の太さ'+' '+CR+CR;
	desctxtObj['dotGrd'] = desctxtObj['cmn']+CR+
				'※線幅：最小のドット（一番上のドット）の直径'+CR+
				'※間隔：上下・左右のドットの中心同士の距離（4以上の偶数で指定）'+CR+
				'※サイズ間隔：最小のドットから何pxずつ大きくするか';

	setRBActiveValue( dirRBObj[typeIdAry[0]], true );
	setEnabled( mainNumObj, optCBObj, true, true, false, false, false, false, false, false );
	var description = dialog.add('statictext',　[ secondL, descriptT, secondL+410, descriptT+80], desctxtObj['common'], true);
	description.justify = 'left';
	description.align = 'bottom';

	// タイプが変更されるたびに制御可能状態の変更
	dirRBObj[typeIdAry[0]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, false, false, false, false, false, false ); description.text=desctxtObj['common']; };
	dirRBObj[typeIdAry[1]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, false, false, false, false, false, false ); description.text=desctxtObj['common']; };
	dirRBObj[typeIdAry[2]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, false, false, false, false, true, false ); description.text=desctxtObj['common']; };
	dirRBObj[typeIdAry[3]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, true, false, false, true, false, false ); description.text=desctxtObj['circle']; };
	dirRBObj[typeIdAry[4]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, true, false, false, true, false, false ); description.text=desctxtObj['circle']; };
	dirRBObj[typeIdAry[5]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, true, false, false, true, false, false ); description.text=desctxtObj['square']; };
	dirRBObj[typeIdAry[6]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, true, false, false, true, false, false ); description.text=desctxtObj['square']; };
	dirRBObj[typeIdAry[7]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, false, false, false, false, false, false, true ); description.text=desctxtObj['harlequin']; };
	dirRBObj[typeIdAry[8]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, false, true, false, false, false, false ); description.text=desctxtObj['common']; };
	dirRBObj[typeIdAry[9]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, false, true, false, false, true, false, false ); description.text=desctxtObj['grid']; };
	dirRBObj[typeIdAry[10]].onClick = function(){setEnabled( mainNumObj, optCBObj, true, true, false, false, true, true, false, false ); description.text=desctxtObj['dotGrd']; };

	// キャンセルボタン
	dialog.cancelBtn = dialog.add('button', [dlgR-430, dlgB-150, dlgR-430+100, dlgB-150+lineheight], 'Cancel', {name: 'cancel'});
	dialog.cancelBtn.onClick = function(){ dialog.close(); }

	// OKボタン
	dialog.okBtn = dialog.add('button',[dlgR-430+100, dlgB-150, dlgR-430+100+120, dlgB-150+lineheight], 'パターン登録', { name:'ok'});
	dialog.okBtn.onClick = function(){
		var selType;
		for(var i in dirRBObj){ if(dirRBObj[i].value == true){ selType=i; } }

		// 数値チェック
		var lwN = parseFloat(mainNumObj['linewidthText'].text);
		var ivN = parseFloat(mainNumObj['intervalText'].text);
		var livN = parseFloat(mainNumObj['lineintervalText'].text);
		var dN = parseFloat(mainNumObj['deepText'].text);
		var sivN = parseFloat(mainNumObj['sizeintervalText'].text);
		var alertMsg = '';
		var CR = String.fromCharCode(13);

		if( !((lwN>=1) && isInteger(lwN)) ){
			alertMsg += '・線幅には1以上の整数を入力してください。' + CR;
		}
		if( selType=='DotGrd' && !((ivN>=4) && ivN%2==0 ) ){
			alertMsg += '・間隔には4以上の偶数を入力してください。' + CR;
		}else if( (mainNumObj['intervalText'].enabled==true) && !((ivN>=0) && isInteger(ivN)) ){
			alertMsg += '・間隔には0以上の整数を入力してください。' + CR;
		}
		if( (mainNumObj['lineintervalText'].enabled==true) && !((livN>=0) && isInteger(livN)) ){
			alertMsg += '・線間隔には0以上の整数を入力してください。' + CR;
		}
		if( (mainNumObj['deepText'].enabled==true) && !((dN>=2) && isInteger(dN)) ){
			alertMsg += '・深さには2以上の整数を入力してください。' + CR;
		}
		if( (mainNumObj['sizeintervalText'].enabled==true) && !((sivN>=1) && isInteger(sivN)) ){
			alertMsg += '・サイズ間隔には1以上の整数を入力してください。' + CR;
		}

		if( alertMsg == '' ){
			// ユーザーの設定単位を取得してから、ピクセルに設定する
			var units = preferences.rulerUnits;
			preferences.rulerUnits = Units.PIXELS;

			optObj['isPullShape'] = optCBObj['pullShape'].value;
			optObj['isRightUp'] = optCBObj['rightUp'].value;
			optObj['isH2times'] = optCBObj['h2times'].value;
			//選択されているタイプでパターン作成
			var patN = makePattern( selType, lwN, ivN, livN, dN, sivN, optObj );
			// パターン登録
			definePattern( patN );
			// ファイルを閉じる
			activeDocument.close(SaveOptions.DONOTSAVECHANGES);
			// 元のファイルで選択しているレイヤーにレイヤー名、パターンを設定
			activeDocument.activeLayer.name = patN;
			setPattern( patN );
			dialog.close();

			// 単位をユーザーの設定に戻す
			preferences.rulerUnits = units;
		}else{
			alert(alertMsg);
		}
	}

	dialog.center();
	dialog.show();
}

// ファイルを新規作成してパターンを作成
// type：			パターンの種類
// linewidth：   	線幅
// interval：		間隔
// lineinterval：	線間隔
// deep：			深さ
// sizeinterval：	サイズ間隔
// optionObj：   	オプション
//  -isPullShape：	抜き
//  -isRightUp：		右上がり
//  -isH2times：		高さ2倍
function makePattern( type, linewidth, interval, lineinterval, deep, sizeinterval, optionObj ){
	var canvasW; var canvasH;
	var prefix; var patName;
	var shapeN;	// 最小単位のドットの形状（Rctn:四角、Elps:円）
	var repeatNum = 0;

	// カンバス情報、基本情報の設定
	switch (type){
		case 'Horizontal':	// 水平
			canvasW = 1;
			canvasH = linewidth+interval;
			break;
		case 'Vertical':	// 垂直
			canvasW = linewidth+interval;
			canvasH = 1;
			break;
		case 'Diagonal':	// 斜線
			canvasW = linewidth+interval;
			canvasH = canvasW;
			break;
		case 'Circle':	// 円ドット
			canvasW = linewidth+interval;
			canvasH = linewidth+lineinterval;
			shapeN = 'Elps';
			prefix = 'c_';
			if( optionObj['isPullShape'] == true ){ prefix='cr_'; }
			break;
		case 'Circle_deg45':	// 円ドット（斜め）
			canvasW = (linewidth+interval)*2;
			canvasH = (linewidth+lineinterval)*2;
			shapeN = 'Elps';
			prefix = 'c45_';
			if( optionObj['isPullShape'] == true ){ prefix='c45r_'; }
			break;
		case 'Square':	// 正方形
			canvasW = linewidth+interval;
			canvasH = linewidth+lineinterval;
			shapeN = 'Rctn';
			prefix = 's_';
			if( optionObj['isPullShape'] == true ){ prefix='sr_'; }
			break;
		case 'Square_deg45':	// 正方形（斜め）
			canvasW = (linewidth+interval)*2;
			canvasH = (linewidth+lineinterval)*2;
			shapeN = 'Rctn';
			prefix = 's45_';
			if( optionObj['isPullShape'] == true ){ prefix='sr45_'; }
			break;
		case 'Harlequin':	// ハーリキン・チェック
			canvasW = linewidth*2;
			canvasH = canvasW;
			if( optionObj['isH2times'] == true ){
            	canvasH = canvasW*2;
			}
			break;
		case 'Jagged':	// ギザギザ
			canvasW = deep*2;
			canvasH = linewidth+interval;
			break;
		case 'Grid_deg45':	// 方眼（斜め）
			canvasW = linewidth+lineinterval*2-1;
			canvasH = canvasW;
			break;
		case 'DotGrd':	// ドットグラデ
			canvasW = interval;
			var radiusSum = 0;
			while( radiusSum <= (Math.sqrt(2)*interval/2) ){
				radiusSum = ((linewidth + repeatNum*sizeinterval) + (linewidth + (repeatNum+1)*sizeinterval))/2;
				repeatNum++;
			}
			if(repeatNum>1){ repeatNum--; }
			canvasH = repeatNum*interval;
			break;
	}

	// 新規カンバス
	preferences.rulerUnits = Units.PIXELS;
	app.documents.add(canvasW,canvasH);

	// タイプごとの処理
	switch (type){
		case 'Horizontal':	// 水平
			makeShape( 'Rctn', 0, 0, 1, linewidth );

			patName = 'h_' + linewidth + '_' + interval;
			break;
		case 'Vertical':	// 垂直
			makeShape( 'Rctn', 0, 0, linewidth, 1 );

			patName = 'v_' + linewidth + '_' + interval;
			break;
		case 'Diagonal':	// 斜線
			for(var i=0; i<canvasW; i++){
				if( canvasW >= i+linewidth ){
					makeShape( 'Rctn', i, i, 1, linewidth );
				}else{
					makeShape( 'Rctn', i, i, 1, canvasW-i );
					makeShape( 'Rctn', i, 0, 1, linewidth-(canvasW-i) );
				}
			}
			prefix = 'dd_';
			if( optionObj['isRightUp'] == true ){
				activeDocument.flipCanvas(Direction.HORIZONTAL);
				prefix='du_';
			}

			patName = prefix + linewidth + '_' + interval;
			break;
		case 'Circle':	// 円ドット
		case 'Square':	// 正方形
			makeShape( shapeN, 0, 0, linewidth, linewidth );
			if( optionObj['isPullShape'] == true ){ pullShape(); }

			patName = prefix + linewidth + '_' + interval + '_' + lineinterval;
			break;
		case 'Circle_deg45':	// 円ドット（斜め）
		case 'Square_deg45':	// 正方形（斜め）
			for(var i=0; i<2; i++){
				makeShape( shapeN, (canvasW/2)*i, (canvasH/2)*i, linewidth, linewidth );
			}
			if( optionObj['isPullShape'] == true ){ pullShape(); }

			patName = prefix + linewidth + '_' + interval + '_' + lineinterval;
			break;
		case 'Harlequin':	// ハーリキン・チェック
			prefix = 'har_';
			var rate = 1;
			if( optionObj['isH2times'] == true ){
				rate = 2;
				prefix = 'harh2_';
			}
			for(var i=0; i<linewidth+1; i++){
				makeShape( 'Rctn', i-1, i*rate, canvasH/rate+1-2*i, rate );
			}
			selectAllLayer();
			copyAndTranslate( 0, linewidth*rate );
			flipShapes('V');

			patName = prefix + linewidth;
			break;
		case 'Jagged':	// ギザギザ
			for(var i=0; i<deep; i++){
				var yPos = i%canvasH;
				if( canvasH >= yPos+linewidth ){
					makeShape( 'Rctn', i, yPos, 1, linewidth );
				}else{
					makeShape( 'Rctn', i, yPos, 1, canvasH-yPos );
					makeShape( 'Rctn', i, 0, 1, linewidth-(canvasH-yPos) );
				}
			}
			selectAllLayer();
			copyAndTranslate( deep, 0 );
			flipShapes('H');

			patName = 'j_' + linewidth + '_' + interval + ' ' + deep;
			break;
		case 'Grid_deg45':	// 方眼（斜め）
			var moveN = parseInt((linewidth-1)/2);
			var dotN = lineinterval + moveN + 1;
			for(var i=0; i<dotN; i++ ){
				makeShape( 'Rctn', i, i-moveN, 1, linewidth );
			}
			selectAllLayer();
			copyAndTranslate( lineinterval+moveN, 0 );
			flipShapes('H');
			selectAllLayer();
			copyAndTranslate( 0, lineinterval+moveN );
			flipShapes('V');

			prefix = 'g45_';
			if( optionObj['isPullShape'] == true ){
				pullShape();
				prefix='g45r_';
			}
			patName = prefix + linewidth + '_' + lineinterval;
			break;
		case 'DotGrd':	// ドットグラデ
			for(var i=0; i<repeatNum; i++){
				for(var j=0; j<2; j++){
					var shapeW = linewidth+sizeinterval*(i*2+j);
					makeShape( 'Elps', -shapeW/2+(canvasW/2)*j, interval/2*(1+i*2+j)-shapeW/2, shapeW, shapeW );
				}
			}
			selectAllLayer();
			copyAndTranslate( canvasW, 0 );

			prefix = 'dg_';
			if( optionObj['isPullShape'] == true ){
				pullShape();
				prefix='dgr_';
			}
			patName = prefix + linewidth + '_' + interval + '_' + sizeinterval;
			break;
	}

	// 背景レイヤーを削除
	var docObj = activeDocument;
	docObj.activeLayer = docObj.layers["背景"];
	docObj.layers["背景"].remove();

	return patName;
}

// 受け取ったオブジェクトの制御可能状態を設定
function setEnabled( mainObj, optObj, isLinewidth, isInterval, isLineintervalText, isDeepText, isSizeintervalText, isPullShape, isRightUp, isH2times ) {
	mainObj['lwText'].enabled = isLinewidth;
	mainObj['linewidthText'].enabled = isLinewidth;
	mainObj['iText'].enabled = isInterval;
	mainObj['intervalText'].enabled = isInterval;
	mainObj['liText'].enabled = isLineintervalText;
	mainObj['lineintervalText'].enabled = isLineintervalText;
	mainObj['dText'].enabled = isDeepText;
	mainObj['deepText'].enabled = isDeepText;
	mainObj['siText'].enabled = isSizeintervalText;
	mainObj['sizeintervalText'].enabled = isSizeintervalText;

	optObj['pullShape'].enabled = isPullShape;
	optObj['rightUp'].enabled = isRightUp;
	optObj['h2times'].enabled = isH2times;
}

// 受け取ったラジオボタンのactive、valueをflgの状態に変更する。
function setRBActiveValue( RBObj, flg ) {
	RBObj.active = flg;
	RBObj.value = flg;
}

// 整数かどうかを返す
function isInteger(x) {
    return Math.round(x) === x;
}

// 受け取ったシェイプタイプ、位置、幅、高さでシェイプを作成
// stype
// 		'Rctn'：長方形
// 		'Elps'：円
function makeShape( stype, x, y, shapeW, shapeH ) {
	var id212 = charIDToTypeID( 'Mk  ' );
	var desc42 = new ActionDescriptor();
	var ref27 = new ActionReference();
	ref27.putClass( stringIDToTypeID( 'contentLayer' ) );
	desc42.putReference( charIDToTypeID( 'null' ), ref27 );
	var desc43 = new ActionDescriptor();
	desc43.putClass( charIDToTypeID( 'Type' ), stringIDToTypeID( 'solidColorLayer' ) );

	var desc44 = new ActionDescriptor();
	desc44.putUnitDouble( charIDToTypeID( 'Top ' ), charIDToTypeID( '#Pxl' ), y );
	desc44.putUnitDouble( charIDToTypeID( 'Left' ), charIDToTypeID( '#Pxl' ), x );
	desc44.putUnitDouble( charIDToTypeID( 'Btom' ), charIDToTypeID( '#Pxl' ), y + shapeH );
	desc44.putUnitDouble(  charIDToTypeID( 'Rght' ), charIDToTypeID( '#Pxl' ), x + shapeW );

	desc43.putObject( charIDToTypeID( 'Shp ' ), charIDToTypeID( stype ), desc44 );
	desc42.putObject( charIDToTypeID( 'Usng' ), stringIDToTypeID( 'contentLayer' ), desc43 );
	executeAction( id212, desc42, DialogModes.NO );
}

// 前面シェイプを削除する
function deleteFrontShape(){
	var desc48 = new ActionDescriptor();
	desc48.putInteger( stringIDToTypeID( "keyOriginType" ), 3 );
	desc48.putDouble( stringIDToTypeID( "keyOriginResolution" ), 72 );
	desc48.putInteger( stringIDToTypeID( "keyActionMode" ), 1 );
	executeAction( stringIDToTypeID( "changePathDetails" ), desc48, DialogModes.NO );
}

// 選択されているシェイプを統合する
function margeShape(){
	executeAction( charIDToTypeID( "Mrg2" ), new ActionDescriptor(), DialogModes.NO );
}

// レイヤーの選択を解除
function selectNoLayer(){
	var desc7 = new ActionDescriptor();
	var ref1 = new ActionReference();
	ref1.putEnumerated( charIDToTypeID( "Lyr " ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) );
	desc7.putReference( charIDToTypeID( "null" ), ref1 );
	executeAction( stringIDToTypeID( "selectNoLayers" ), desc7, DialogModes.NO );
}

// 全てのレイヤーを選択
function selectAllLayer(){
	var desc2 = new ActionDescriptor();
	var ref1 = new ActionReference();
	ref1.putEnumerated( charIDToTypeID( "Lyr " ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) );
	desc2.putReference( charIDToTypeID( "null" ), ref1 );
	executeAction( stringIDToTypeID( "selectAllLayers" ), desc2, DialogModes.NO );
}

// シェイプを抜く
function pullShape(){
	// そのまま全レイヤー選択できないことがあるので一度選択解除
	selectNoLayer();
	selectAllLayer();
	// 背景と自身以外にレイヤーがある場合
	if( activeDocument.artLayers.length > 2 ){
		margeShape();
	}
	deleteFrontShape();
}

// 受け取った角度で中央を基準に回転する
function rotateShape( angle ){
	var desc17 = new ActionDescriptor();
	var ref5 = new ActionReference();
	ref5.putEnumerated( charIDToTypeID( "Lyr " ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) );
	desc17.putReference( charIDToTypeID( "null" ), ref5 );
	desc17.putEnumerated( charIDToTypeID( "FTcs" ), charIDToTypeID( "QCSt" ), charIDToTypeID( "Qcsa" ) );
	var desc18 = new ActionDescriptor();
	desc18.putUnitDouble( charIDToTypeID( "Hrzn" ), charIDToTypeID( "#Pxl", 0 ) );
	desc18.putUnitDouble( charIDToTypeID( "Vrtc" ), charIDToTypeID( "#Pxl", 0 ) );
	desc17.putObject( charIDToTypeID( "Ofst" ), charIDToTypeID( "Ofst" ), desc18 );
	desc17.putUnitDouble( charIDToTypeID( "Angl"), charIDToTypeID( "#Ang"), angle );
	desc17.putEnumerated( charIDToTypeID( "Intr" ), charIDToTypeID( "Intp" ), charIDToTypeID( "Bcbc" ) );
	executeAction( charIDToTypeID( "Trnf" ), desc17, DialogModes.NO );
}

// 受け取った座標分移動した位置に複製する
function copyAndTranslate( transX, transY ){
	var idCpTL = charIDToTypeID( "CpTL" );
	executeAction( idCpTL, undefined, DialogModes.NO );
	activeDocument.activeLayer.translate( transX, transY );
}

// 選択されているオブジェクトを受け取った方向に反転
function flipShapes( direction ){
	var drtn;
  	switch (direction){
		case 'H': drtn = 'Hrzn'; break;
		case 'V': drtn = 'Vrtc'; break;
	}

	var desc13 = new ActionDescriptor();
	var ref8 = new ActionReference();
	ref8.putEnumerated( charIDToTypeID( "Lyr " ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) );
	desc13.putReference( charIDToTypeID( "null" ), ref8 );
	desc13.putEnumerated( charIDToTypeID( "Axis" ), charIDToTypeID( "Ornt" ), charIDToTypeID( drtn ) );
	executeAction( charIDToTypeID( "Flip" ), desc13, DialogModes.NO );
}

// 受け取った名前で、現在のカンバスの状態をパターン登録する
function definePattern( docName ){
	var desc1 = new ActionDescriptor();
	var ref1 = new ActionReference();
	ref1.putClass(charIDToTypeID('Ptrn'));
	desc1.putReference(charIDToTypeID('null'), ref1);
	var ref2 = new ActionReference();
	ref2.putProperty( charIDToTypeID('Prpr'), charIDToTypeID('fsel') );
	ref2.putEnumerated( charIDToTypeID('Dcmn'), charIDToTypeID('Ordn'), charIDToTypeID('Trgt') );
	desc1.putReference(charIDToTypeID('Usng'), ref2);
	desc1.putString( charIDToTypeID('Nm  '), docName );
	executeAction( charIDToTypeID('Mk  '), desc1, DialogModes.NO );
}

// 選択中のオブジェクトに、指定したパターン名のパターンを設定する
function setPattern( pname ){
	var desc24 = new ActionDescriptor();
	var ref4 = new ActionReference();
	ref4.putEnumerated( charIDToTypeID( "Lyr " ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) );
	desc24.putReference( charIDToTypeID( "null" ), ref4 );
	var desc25 = new ActionDescriptor();
	var desc26 = new ActionDescriptor();
	var desc27 = new ActionDescriptor();
	desc27.putString( charIDToTypeID( "Nm  " ), pname );
	// 後半の文字列が以前のPhotoshopバージョンだと"bae1a340-4af5-117a-b106-d0321fbe7181"で動いていた。
	desc27.putString( charIDToTypeID( "Idnt" ), "60097e26-92e9-0045-9e94-a5837c5f2544" );
	desc26.putObject( charIDToTypeID( "Ptrn" ), charIDToTypeID( "Ptrn" ), desc27 );
	var desc28 = new ActionDescriptor();
	desc28.putDouble( charIDToTypeID( "Hrzn" ), 0.000000 );
	desc28.putDouble( charIDToTypeID( "Vrtc" ), 0.000000 );
	desc25.putObject( stringIDToTypeID( "patternFill" ), stringIDToTypeID( "patternFill" ), desc26 );
	desc24.putObject( charIDToTypeID( "T   " ), charIDToTypeID( "Lefx" ), desc25 );
	executeAction( charIDToTypeID( "setd" ), desc24, DialogModes.NO );
}
